var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Output, Input, EventEmitter } from "@angular/core";
import { FormBuilder, FormControl, Validators } from "@angular/forms";
var HTML_COMPONENT = "\n<div>\n<form [formGroup]=\"validations_form\">\n<div [ngStyle]=\"this.customStyle.styleDivInputText\">\n  <ion-icon [ngStyle]=\"this.customStyle.styleUserIcon\" name=\"md-person\"></ion-icon>\n  <ion-input\n    type=\"text\"\n    formControlName=\"username\"\n    [ngStyle]=\"this.customStyle.styleInputText\"\n    required\n    [(ngModel)]=\"this.username\"\n    (keyup)=emit()\n  ></ion-input>\n</div>\n<div [ngStyle]=\"this.customStyle.styleDivErrors\">\n  <ng-container *ngFor=\"let validation of validation_messages.username\">\n    <div\n    [ngStyle]=\"this.customStyle.styleDivErrorMessage\"\n      *ngIf=\"\n        validations_form.get('username').hasError(validation.type) &&\n        (validations_form.get('username').dirty ||\n          validations_form.get('username').touched)\n      \"\n    >\n      {{ validation.message }}\n    </div>\n  </ng-container>\n</div>\n</form>\n</div>\n";
var FormUsername = /** @class */ (function () {
    function FormUsername(formBuilder) {
        this.formBuilder = formBuilder;
        this.usernameReturn = new EventEmitter();
        this.customStyle = {};
        this.validation_messages = {
            username: []
        };
    }
    FormUsername.prototype.emit = function () {
        this.usernameReturn.emit({
            username: this.validations_form.get("username").value,
            valid: this.validations_form.get("username").status === "VALID"
        });
    };
    FormUsername.prototype.ngOnInit = function () {
        this.validations_form = this.formBuilder.group({
            username: new FormControl("", Validators.compose([
                Validators.maxLength(this.maxLength !== undefined ? this.maxLength : 25),
                Validators.minLength(this.minLength !== undefined ? this.minLength : 5),
                Validators.pattern(this.pattern !== undefined
                    ? this.pattern
                    : "^(?=.*[a-zA-Z])(?=.*[0-9])[a-zA-Z0-9]+$"),
                this.required !== undefined && this.required
                    ? Validators.required
                    : null
            ]))
        });
        this.customStyle = {
            styleDivInputText: this.styleDivInputText !== undefined
                ? JSON.parse(this.styleDivInputText)
                : JSON.parse("{ \"display\": \"flex\" ,\n      \"align-items\": \"center\",\n      \"margin-top\": \"5px\",\n      \"padding\": \"0\",\n      \"background\": \"var(--ion-color-primary)\",\n      \"border-radius\": \"0.5em\"}"),
            styleUserIcon: this.styleUserIcon !== undefined
                ? JSON.parse(this.styleUserIcon)
                : JSON.parse("{\n        \"color\": \"var(--ion-color-primary-contrast)\",\n        \"float\": \"left\",\n        \"font-size\": \"20px\",\n        \"margin-left\": \"3px\"\n        }"),
            styleInputText: this.styleInputText !== undefined
                ? JSON.parse(this.styleInputText)
                : JSON.parse("{\n        \"color\": \"var(--ion-color-primary-contrast)\"\n        }"),
            styleDivErrors: this.styleDivErrors !== undefined
                ? JSON.parse(this.styleDivErrors)
                : JSON.parse("{\"display\": \"flex\",\n      \"flex-direction\":\"column\",\n    \"justify-content\": \"center\",\n    \"align-items\": \"center\"\n    }"),
            styleDivErrorMessage: this.styleDivErrorMessage !== undefined
                ? JSON.parse(this.styleDivErrorMessage)
                : JSON.parse("{\"font-size\": \"0.9em\",\n        \"margin-top\": \"3px\",\n        \"color\": \"var(--ion-color-danger)\"\n        }")
        };
        this.validation_messages = {
            username: [
                {
                    type: "required",
                    message: this.errMsgRequired !== undefined
                        ? this.errMsgRequired
                        : "Username is required"
                },
                {
                    type: "minlength",
                    message: this.errMsgMinlength !== undefined
                        ? this.errMsgMinlength
                        : "Username must be at least 5 characters long."
                },
                {
                    type: "maxlength",
                    message: this.errMsgMaxlength !== undefined
                        ? this.errMsgMaxlength
                        : "Username cannot be more than 25 characters long."
                },
                {
                    type: "pattern",
                    message: this.errMsgpattern !== undefined
                        ? this.errMsgpattern
                        : "Your username must contain only numbers and letters."
                },
                {
                    type: "validUsername",
                    message: this.errMsgValidUsername !== undefined
                        ? this.errMsgValidUsername
                        : "Your username has already been taken."
                }
            ]
        };
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], FormUsername.prototype, "required", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], FormUsername.prototype, "maxLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], FormUsername.prototype, "minLength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "pattern", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "username", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "styleDivInputText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "styleUserIcon", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "styleInputText", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "styleDivErrors", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "styleDivErrorMessage", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "errMsgRequired", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "errMsgMinlength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "errMsgMaxlength", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "errMsgpattern", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], FormUsername.prototype, "errMsgValidUsername", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], FormUsername.prototype, "usernameReturn", void 0);
    FormUsername = __decorate([
        Component({
            selector: "form-username",
            template: HTML_COMPONENT
        }),
        __metadata("design:paramtypes", [FormBuilder])
    ], FormUsername);
    return FormUsername;
}());
export { FormUsername };
//# sourceMappingURL=form-username-component.js.map